<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.efm.util;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.util.Arrays;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.util.BitSet;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.util.logging.Level;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.util.logging.Logger;<a name="line.39"></a>
<FONT color="green">040</FONT>    <a name="line.40"></a>
<FONT color="green">041</FONT>    import ch.javasoft.math.BigFraction;<a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.math.NumberOperations;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.metabolic.FluxDistribution;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.metabolic.MetabolicNetwork;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.metabolic.Reaction;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.metabolic.efm.column.Column;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.metabolic.efm.column.ColumnHome;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.metabolic.efm.config.Config;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.metabolic.efm.model.ColumnToFluxDistributionConverter;<a name="line.49"></a>
<FONT color="green">050</FONT>    import ch.javasoft.metabolic.efm.model.NetworkEfmModel;<a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.metabolic.efm.model.nullspace.CannotReconstructFluxException;<a name="line.51"></a>
<FONT color="green">052</FONT>    import ch.javasoft.metabolic.efm.sort.SortUtil;<a name="line.52"></a>
<FONT color="green">053</FONT>    import ch.javasoft.metabolic.util.StoichiometricMatrices;<a name="line.53"></a>
<FONT color="green">054</FONT>    import ch.javasoft.smx.iface.BigIntegerRationalMatrix;<a name="line.54"></a>
<FONT color="green">055</FONT>    import ch.javasoft.smx.iface.DoubleMatrix;<a name="line.55"></a>
<FONT color="green">056</FONT>    import ch.javasoft.smx.iface.ReadableBigIntegerRationalMatrix;<a name="line.56"></a>
<FONT color="green">057</FONT>    import ch.javasoft.smx.iface.ReadableDoubleMatrix;<a name="line.57"></a>
<FONT color="green">058</FONT>    import ch.javasoft.smx.iface.ReadableMatrix;<a name="line.58"></a>
<FONT color="green">059</FONT>    import ch.javasoft.smx.iface.WritableMatrix;<a name="line.59"></a>
<FONT color="green">060</FONT>    import ch.javasoft.smx.impl.DefaultBigIntegerRationalMatrix;<a name="line.60"></a>
<FONT color="green">061</FONT>    import ch.javasoft.smx.impl.DefaultDoubleMatrix;<a name="line.61"></a>
<FONT color="green">062</FONT>    import ch.javasoft.smx.ops.Gauss;<a name="line.62"></a>
<FONT color="green">063</FONT>    import ch.javasoft.smx.ops.Mul;<a name="line.63"></a>
<FONT color="green">064</FONT>    import ch.javasoft.util.genarr.ArrayIterable;<a name="line.64"></a>
<FONT color="green">065</FONT>    import ch.javasoft.util.genarr.GenericDynamicArray;<a name="line.65"></a>
<FONT color="green">066</FONT>    import ch.javasoft.util.logging.LogWriter;<a name="line.66"></a>
<FONT color="green">067</FONT>    import ch.javasoft.util.logging.Loggers;<a name="line.67"></a>
<FONT color="green">068</FONT>    <a name="line.68"></a>
<FONT color="green">069</FONT>    public class EfmHelper {<a name="line.69"></a>
<FONT color="green">070</FONT>            <a name="line.70"></a>
<FONT color="green">071</FONT>            private static final Logger LOG = LogPkg.LOGGER;<a name="line.71"></a>
<FONT color="green">072</FONT>            <a name="line.72"></a>
<FONT color="green">073</FONT>            /**<a name="line.73"></a>
<FONT color="green">074</FONT>             * For every external-to-external (e2e) reactions (a reactions which is <a name="line.74"></a>
<FONT color="green">075</FONT>             * uptake and excretion reaction at the same time), we add an EFM. This EFM <a name="line.75"></a>
<FONT color="green">076</FONT>             * has flux value one for the e2e reaction, zero for all other reactions. If <a name="line.76"></a>
<FONT color="green">077</FONT>             * the 2e2 reaction is reversible, another EFM with -1 at this reaction is<a name="line.77"></a>
<FONT color="green">078</FONT>             * added. <a name="line.78"></a>
<FONT color="green">079</FONT>             */<a name="line.79"></a>
<FONT color="green">080</FONT>            public static &lt;N extends Number, Col extends Column&gt; int appendExternalExternalFluxModes(GenericDynamicArray&lt;FluxDistribution&gt; fluxes, MetabolicNetwork metaNet, ColumnHome&lt;N, Col&gt; columnHome) {<a name="line.80"></a>
<FONT color="green">081</FONT>                    int count = 0;<a name="line.81"></a>
<FONT color="green">082</FONT>                    final NumberOperations&lt;N&gt; numberOps = columnHome.getNumberOperations();<a name="line.82"></a>
<FONT color="green">083</FONT>                    //append flux for external to external reactions<a name="line.83"></a>
<FONT color="green">084</FONT>                    final ArrayIterable&lt;? extends Reaction&gt; reacts = metaNet.getReactions();<a name="line.84"></a>
<FONT color="green">085</FONT>                    for (int ii = 0; ii &lt; reacts.length(); ii++) {<a name="line.85"></a>
<FONT color="green">086</FONT>                            Reaction reac = reacts.get(ii);<a name="line.86"></a>
<FONT color="green">087</FONT>                            if (reac.isUptake() &amp;&amp; reac.isExtract()) {<a name="line.87"></a>
<FONT color="green">088</FONT>                                    count++;<a name="line.88"></a>
<FONT color="green">089</FONT>                                    final N[] rates = numberOps.newArray(reacts.length());<a name="line.89"></a>
<FONT color="green">090</FONT>                                    Arrays.fill(rates, numberOps.zero());<a name="line.90"></a>
<FONT color="green">091</FONT>                                    rates[ii] = numberOps.one();<a name="line.91"></a>
<FONT color="green">092</FONT>                                    fluxes.add(columnHome.createFluxDistribution(metaNet, rates));<a name="line.92"></a>
<FONT color="green">093</FONT>                                    if (reac.getConstraints().isReversible()) {<a name="line.93"></a>
<FONT color="green">094</FONT>                                            count++;<a name="line.94"></a>
<FONT color="green">095</FONT>                                            final N[] ratesRev = rates.clone();<a name="line.95"></a>
<FONT color="green">096</FONT>                                            ratesRev[ii] = numberOps.negate(numberOps.one());<a name="line.96"></a>
<FONT color="green">097</FONT>                                            fluxes.add(columnHome.createFluxDistribution(metaNet, ratesRev));<a name="line.97"></a>
<FONT color="green">098</FONT>                                    }<a name="line.98"></a>
<FONT color="green">099</FONT>                            }<a name="line.99"></a>
<FONT color="green">100</FONT>                    }<a name="line.100"></a>
<FONT color="green">101</FONT>                    return count;<a name="line.101"></a>
<FONT color="green">102</FONT>            }<a name="line.102"></a>
<FONT color="green">103</FONT>            /**<a name="line.103"></a>
<FONT color="green">104</FONT>             * Tests whether the given column, partly represented only by boolean <a name="line.104"></a>
<FONT color="green">105</FONT>             * values, is still a valid EFM by converting all values to numeric. If the<a name="line.105"></a>
<FONT color="green">106</FONT>             * boolean part is buggy, this conversion will fail, since no or multiple<a name="line.106"></a>
<FONT color="green">107</FONT>             * solutions exist with the faulty boolean pattern.<a name="line.107"></a>
<FONT color="green">108</FONT>             * &lt;p&gt;<a name="line.108"></a>
<FONT color="green">109</FONT>             * On failure, debug information is logged and an exception is thrown.<a name="line.109"></a>
<FONT color="green">110</FONT>             * <a name="line.110"></a>
<FONT color="green">111</FONT>             * @throws CannotReconstructFluxException if the test fails<a name="line.111"></a>
<FONT color="green">112</FONT>             */<a name="line.112"></a>
<FONT color="green">113</FONT>            public static &lt;N extends Number, Col extends Column&gt; void efmSelfTest(ColumnToFluxDistributionConverter&lt;N, Col&gt; converter, Config config, NetworkEfmModel model, Col newCol, Col oldA, Col oldB) {<a name="line.113"></a>
<FONT color="green">114</FONT>                    //test the newly generated column<a name="line.114"></a>
<FONT color="green">115</FONT>                    try {<a name="line.115"></a>
<FONT color="green">116</FONT>                            converter.createFluxDistributionFromColumn(config, model, newCol);<a name="line.116"></a>
<FONT color="green">117</FONT>                    }<a name="line.117"></a>
<FONT color="green">118</FONT>                    catch (CannotReconstructFluxException ex) {<a name="line.118"></a>
<FONT color="green">119</FONT>                            FluxDistribution fluxA, fluxB;<a name="line.119"></a>
<FONT color="green">120</FONT>                            try {<a name="line.120"></a>
<FONT color="green">121</FONT>                                    fluxA = converter.createFluxDistributionFromColumn(config, model, oldA);<a name="line.121"></a>
<FONT color="green">122</FONT>                            }<a name="line.122"></a>
<FONT color="green">123</FONT>                            catch (CannotReconstructFluxException e) {fluxA = null;}<a name="line.123"></a>
<FONT color="green">124</FONT>                            try {<a name="line.124"></a>
<FONT color="green">125</FONT>                                    fluxB = converter.createFluxDistributionFromColumn(config, model, oldB);<a name="line.125"></a>
<FONT color="green">126</FONT>                            }<a name="line.126"></a>
<FONT color="green">127</FONT>                            catch (CannotReconstructFluxException e) {fluxB = null;}<a name="line.127"></a>
<FONT color="green">128</FONT>                            LOG.severe("new column is not a valid flux mode (old.A is " + (fluxA != null ? "ok" : "nok") + ", old.B is " + (fluxB != null ? "ok" : "nok") + ")");<a name="line.128"></a>
<FONT color="green">129</FONT>                            LOG.severe("new   = " + newCol);<a name="line.129"></a>
<FONT color="green">130</FONT>                            LOG.severe("old.A = " + oldA);<a name="line.130"></a>
<FONT color="green">131</FONT>                            LOG.severe("old.B = " + oldB);<a name="line.131"></a>
<FONT color="green">132</FONT>                            LOG.severe("nullspace for new is:");<a name="line.132"></a>
<FONT color="green">133</FONT>                            ex.getNullspace().writeToMultiline(new LogWriter(LOG, Level.SEVERE));<a name="line.133"></a>
<FONT color="green">134</FONT>                            int[] rowUnmappings = rowUnmappings(model.getReactionSorting());<a name="line.134"></a>
<FONT color="green">135</FONT>                            if (fluxA != null) LOG.severe("flux.A = " + Arrays.toString(mapRows(fluxA.getDoubleRates(), rowUnmappings)));<a name="line.135"></a>
<FONT color="green">136</FONT>                            if (fluxB != null) LOG.severe("flux.B = " + Arrays.toString(mapRows(fluxB.getDoubleRates(), rowUnmappings)));<a name="line.136"></a>
<FONT color="green">137</FONT>                            throw ex;<a name="line.137"></a>
<FONT color="green">138</FONT>                    }               <a name="line.138"></a>
<FONT color="green">139</FONT>            }<a name="line.139"></a>
<FONT color="green">140</FONT>            <a name="line.140"></a>
<FONT color="green">141</FONT>        private static DoubleMatrix createKernelDbl(MetabolicNetwork metaNet, DoubleMatrix mx, int[] rowMapping, Config config, boolean log) {<a name="line.141"></a>
<FONT color="green">142</FONT>            BigIntegerRationalMatrix biMx = new DefaultBigIntegerRationalMatrix(<a name="line.142"></a>
<FONT color="green">143</FONT>                    mx.toDoubleArray(), mx.getRowCount(), mx.getColumnCount(), true /*adjust double values*/        <a name="line.143"></a>
<FONT color="green">144</FONT>            );<a name="line.144"></a>
<FONT color="green">145</FONT>            return createKernel(metaNet, biMx, rowMapping, config, log).toDoubleMatrix(false /*enfordeNewInstance*/);<a name="line.145"></a>
<FONT color="green">146</FONT>        }<a name="line.146"></a>
<FONT color="green">147</FONT>        //FIXME resolve stoich/kernel type stuff<a name="line.147"></a>
<FONT color="green">148</FONT>        @SuppressWarnings("unchecked")<a name="line.148"></a>
<FONT color="green">149</FONT>            public static &lt;M extends ReadableMatrix&lt;?&gt;&gt; M createKernel(MetabolicNetwork metaNet, M mx, int[] rowMapping, Config config, boolean log) {<a name="line.149"></a>
<FONT color="green">150</FONT>                    if (mx instanceof BigIntegerRationalMatrix) {<a name="line.150"></a>
<FONT color="green">151</FONT>                            return (M)createKernelBI(metaNet, (BigIntegerRationalMatrix)mx, rowMapping, config, log);<a name="line.151"></a>
<FONT color="green">152</FONT>                    }<a name="line.152"></a>
<FONT color="green">153</FONT>                    else if (mx instanceof ReadableBigIntegerRationalMatrix) {<a name="line.153"></a>
<FONT color="green">154</FONT>                            return (M)createKernelBI(metaNet, (ReadableBigIntegerRationalMatrix)mx, rowMapping, config, log);<a name="line.154"></a>
<FONT color="green">155</FONT>                    }<a name="line.155"></a>
<FONT color="green">156</FONT>                    else if (mx instanceof DoubleMatrix) {<a name="line.156"></a>
<FONT color="green">157</FONT>                            return (M)createKernelDbl(metaNet, (DoubleMatrix)mx, rowMapping, config, log);<a name="line.157"></a>
<FONT color="green">158</FONT>    //                      return (M)createKernel(metaNet, (DoubleMatrix)mx, rowMapping, config, log);<a name="line.158"></a>
<FONT color="green">159</FONT>                    }<a name="line.159"></a>
<FONT color="green">160</FONT>                    throw new RuntimeException("unsupported matrix type: " + mx.getClass().getName());<a name="line.160"></a>
<FONT color="green">161</FONT>        }<a name="line.161"></a>
<FONT color="green">162</FONT>        //This method is not really stable since nullspace computation uses large pivots, but its better to use 1 pivots since<a name="line.162"></a>
<FONT color="green">163</FONT>        //many math examples contain a lot of ones<a name="line.163"></a>
<FONT color="green">164</FONT>        @SuppressWarnings("unused")<a name="line.164"></a>
<FONT color="green">165</FONT>            private static DoubleMatrix createKernelDblOld(MetabolicNetwork metaNet, DoubleMatrix mx, int[] rowMapping, Config config, boolean log) {<a name="line.165"></a>
<FONT color="green">166</FONT>            final DoubleMatrix biKn = new Gauss(config.zero().mZeroPos).nullspace(mx);      <a name="line.166"></a>
<FONT color="green">167</FONT>            final DoubleMatrix kn   = formatKernel(metaNet, biKn, rowMapping, config);<a name="line.167"></a>
<FONT color="green">168</FONT>            sortKernel(metaNet, mx, kn, rowMapping, config, log);<a name="line.168"></a>
<FONT color="green">169</FONT>            return kn;<a name="line.169"></a>
<FONT color="green">170</FONT>        }<a name="line.170"></a>
<FONT color="green">171</FONT>        private static BigIntegerRationalMatrix createKernelBI(MetabolicNetwork metaNet, ReadableBigIntegerRationalMatrix&lt;BigFraction&gt; mx, int[] rowMapping, Config config, boolean log) {<a name="line.171"></a>
<FONT color="green">172</FONT>            final BigIntegerRationalMatrix biKn = Gauss.getRationalInstance().nullspace(mx);<a name="line.172"></a>
<FONT color="green">173</FONT>            final BigIntegerRationalMatrix kn       = formatKernel(metaNet, biKn, rowMapping, config);<a name="line.173"></a>
<FONT color="green">174</FONT>            sortKernel(metaNet, mx, kn, rowMapping, config, log);<a name="line.174"></a>
<FONT color="green">175</FONT>            return kn;<a name="line.175"></a>
<FONT color="green">176</FONT>        }<a name="line.176"></a>
<FONT color="green">177</FONT>        private static &lt;N extends Number, M extends ReadableDoubleMatrix&lt;N&gt; &amp; WritableMatrix&lt;N&gt;&gt; void sortKernel(MetabolicNetwork metaNet, ReadableDoubleMatrix&lt;N&gt; stoich, M kernel, int[] rowMapping, Config config, boolean log) {<a name="line.177"></a>
<FONT color="green">178</FONT>            if (log &amp;&amp; LOG.isLoggable(Level.FINE)) {<a name="line.178"></a>
<FONT color="green">179</FONT>                LogWriter fineWriter = new LogWriter(LOG, Level.FINE);<a name="line.179"></a>
<FONT color="green">180</FONT>                LOG.finer("stoichiometrix matrix");<a name="line.180"></a>
<FONT color="green">181</FONT>                new DefaultDoubleMatrix(<a name="line.181"></a>
<FONT color="green">182</FONT>                    StoichiometricMatrices.createStoichiometricMatrix(metaNet), true<a name="line.182"></a>
<FONT color="green">183</FONT>                ).writeToMultiline(fineWriter);<a name="line.183"></a>
<FONT color="green">184</FONT>            }<a name="line.184"></a>
<FONT color="green">185</FONT>            if (log &amp;&amp; LOG.isLoggable(Level.FINER)) {<a name="line.185"></a>
<FONT color="green">186</FONT>                LogWriter finerWriter = new LogWriter(LOG, Level.FINER);<a name="line.186"></a>
<FONT color="green">187</FONT>                LOG.finer("expanded stoichiometric matrix");<a name="line.187"></a>
<FONT color="green">188</FONT>                stoich.writeToMultiline(finerWriter);<a name="line.188"></a>
<FONT color="green">189</FONT>                LOG.finer("kernel matrix (unmapped):");<a name="line.189"></a>
<FONT color="green">190</FONT>                    kernel.writeToMultiline(finerWriter);<a name="line.190"></a>
<FONT color="green">191</FONT>                    LOG.finer("kernel matrix:");<a name="line.191"></a>
<FONT color="green">192</FONT>                    ReactionMapping.unsortKernelMatrixRows(kernel, rowMapping).writeToMultiline(finerWriter);<a name="line.192"></a>
<FONT color="green">193</FONT>            }<a name="line.193"></a>
<FONT color="green">194</FONT>            SortUtil.sortKernel(kernel, rowMapping, metaNet, config);<a name="line.194"></a>
<FONT color="green">195</FONT>            if (log &amp;&amp; LOG.isLoggable(Level.FINE)) {          <a name="line.195"></a>
<FONT color="green">196</FONT>                    LOG.fine("reaction-sorting  (KERNEL): " + Arrays.toString(rowMapping));<a name="line.196"></a>
<FONT color="green">197</FONT>            }<a name="line.197"></a>
<FONT color="green">198</FONT>            if (log &amp;&amp; LOG.isLoggable(Level.FINER)) {          <a name="line.198"></a>
<FONT color="green">199</FONT>                LogWriter finerWriter = new LogWriter(LOG, Level.FINER);<a name="line.199"></a>
<FONT color="green">200</FONT>                LOG.finer("initial kernel matrix (sorted):");<a name="line.200"></a>
<FONT color="green">201</FONT>                kernel.writeToMultiline(finerWriter);<a name="line.201"></a>
<FONT color="green">202</FONT>                LOG.finer("mx * kernel:");<a name="line.202"></a>
<FONT color="green">203</FONT>                EfmHelper.mulMapped(stoich, kernel, rowMapping).writeToMultiline(finerWriter);<a name="line.203"></a>
<FONT color="green">204</FONT>            }<a name="line.204"></a>
<FONT color="green">205</FONT>        }<a name="line.205"></a>
<FONT color="green">206</FONT>            <a name="line.206"></a>
<FONT color="green">207</FONT>        <a name="line.207"></a>
<FONT color="green">208</FONT>            //it already might be an echolon form:<a name="line.208"></a>
<FONT color="green">209</FONT>            //if kernel was computed with gauss, k=[-M I]' contains an identity <a name="line.209"></a>
<FONT color="green">210</FONT>            //matrix, but the id metas can be anywhere.<a name="line.210"></a>
<FONT color="green">211</FONT>            //first, we try to account for this.<a name="line.211"></a>
<FONT color="green">212</FONT>        //if this does not work, we use the double matrix method formatKernel<a name="line.212"></a>
<FONT color="green">213</FONT>        private static &lt;N extends Number, M extends ReadableDoubleMatrix&lt;N&gt; &amp; WritableMatrix&lt;N&gt;&gt; M formatKernel(MetabolicNetwork metaNet, M kn, int[] rowMapping, Config config) {<a name="line.213"></a>
<FONT color="green">214</FONT>            final int rows = kn.getRowCount();<a name="line.214"></a>
<FONT color="green">215</FONT>            final int cols = kn.getColumnCount();<a name="line.215"></a>
<FONT color="green">216</FONT>            final NumberOperations&lt;N&gt; nops = kn.getNumberOperations();<a name="line.216"></a>
<FONT color="green">217</FONT>            final N zero = nops.valueOf(config.zero().mZeroPos);<a name="line.217"></a>
<FONT color="green">218</FONT>            final N oneU = nops.add(nops.one(), zero);<a name="line.218"></a>
<FONT color="green">219</FONT>            final N oneL = nops.subtract(nops.one(), zero);<a name="line.219"></a>
<FONT color="green">220</FONT>            BitSet pivots = new BitSet(cols);<a name="line.220"></a>
<FONT color="green">221</FONT>            int rowEnd = rows;<a name="line.221"></a>
<FONT color="green">222</FONT>            int row = 0;<a name="line.222"></a>
<FONT color="green">223</FONT>            while (row &lt; rowEnd) {<a name="line.223"></a>
<FONT color="green">224</FONT>                    if (pivots.get(row)) {<a name="line.224"></a>
<FONT color="green">225</FONT>                            row++;<a name="line.225"></a>
<FONT color="green">226</FONT>                    }<a name="line.226"></a>
<FONT color="green">227</FONT>                    else {<a name="line.227"></a>
<FONT color="green">228</FONT>                            int cnt0 = 0;<a name="line.228"></a>
<FONT color="green">229</FONT>                            int pos1 = -1;<a name="line.229"></a>
<FONT color="green">230</FONT>                            for (int col = 0; col &lt; cols; col++) {<a name="line.230"></a>
<FONT color="green">231</FONT>                                    if (kn.getSignumAt(row, col) == 0) {<a name="line.231"></a>
<FONT color="green">232</FONT>                                            cnt0++;<a name="line.232"></a>
<FONT color="green">233</FONT>                                    }<a name="line.233"></a>
<FONT color="green">234</FONT>                                    else {<a name="line.234"></a>
<FONT color="green">235</FONT>                                            final N val = kn.getNumberValueAt(row, col);<a name="line.235"></a>
<FONT color="green">236</FONT>                                            final N abs = nops.abs(val);<a name="line.236"></a>
<FONT color="green">237</FONT>                                            if (nops.compare(abs, zero) &lt; 0) {<a name="line.237"></a>
<FONT color="green">238</FONT>                                                    cnt0++;<a name="line.238"></a>
<FONT color="green">239</FONT>                                                    kn.setValueAt(row, col, nops.zero());<a name="line.239"></a>
<FONT color="green">240</FONT>                                            }<a name="line.240"></a>
<FONT color="green">241</FONT>                                            else if (pos1 == -1 &amp;&amp; nops.isOne(val)) { <a name="line.241"></a>
<FONT color="green">242</FONT>                                                    pos1 = col;<a name="line.242"></a>
<FONT color="green">243</FONT>                                            }<a name="line.243"></a>
<FONT color="green">244</FONT>                                            else if (pos1 == -1 &amp;&amp; <a name="line.244"></a>
<FONT color="green">245</FONT>                                                    (nops.compare(val, oneU) &lt; 0 &amp;&amp; nops.compare(val, oneL) &gt; 0)<a name="line.245"></a>
<FONT color="green">246</FONT>                                            ) {<a name="line.246"></a>
<FONT color="green">247</FONT>                                                    <a name="line.247"></a>
<FONT color="green">248</FONT>                                                    pos1 = col;<a name="line.248"></a>
<FONT color="green">249</FONT>                                                    kn.setValueAt(row, col, nops.one());<a name="line.249"></a>
<FONT color="green">250</FONT>                                            }<a name="line.250"></a>
<FONT color="green">251</FONT>                                            else {<a name="line.251"></a>
<FONT color="green">252</FONT>                                                    break;<a name="line.252"></a>
<FONT color="green">253</FONT>                                            }<a name="line.253"></a>
<FONT color="green">254</FONT>                                    }<a name="line.254"></a>
<FONT color="green">255</FONT>                            }<a name="line.255"></a>
<FONT color="green">256</FONT>                            if (pos1 != -1 &amp;&amp; cnt0 == cols - 1) {<a name="line.256"></a>
<FONT color="green">257</FONT>                                    if (pivots.get(pos1)) {<a name="line.257"></a>
<FONT color="green">258</FONT>                                            //we have already such a pivot row<a name="line.258"></a>
<FONT color="green">259</FONT>                                            //(NOTE, we could clear the one, so this should probably<a name="line.259"></a>
<FONT color="green">260</FONT>                                            //not happen)<a name="line.260"></a>
<FONT color="green">261</FONT>                                            <a name="line.261"></a>
<FONT color="green">262</FONT>                                            //move this row to the end<a name="line.262"></a>
<FONT color="green">263</FONT>                                            rowEnd--;<a name="line.263"></a>
<FONT color="green">264</FONT>                                            if (row != rowEnd) {<a name="line.264"></a>
<FONT color="green">265</FONT>                                kn.swapRows(row, rowEnd);<a name="line.265"></a>
<FONT color="green">266</FONT>                                int tmp = rowMapping[row];<a name="line.266"></a>
<FONT color="green">267</FONT>                                rowMapping[row]             = rowMapping[rowEnd];<a name="line.267"></a>
<FONT color="green">268</FONT>                                rowMapping[rowEnd]  = tmp;                                          <a name="line.268"></a>
<FONT color="green">269</FONT>                                            }<a name="line.269"></a>
<FONT color="green">270</FONT>                                    }<a name="line.270"></a>
<FONT color="green">271</FONT>                                    else {<a name="line.271"></a>
<FONT color="green">272</FONT>                                            //found a pivot row, move it to pivot position<a name="line.272"></a>
<FONT color="green">273</FONT>                                            pivots.set(pos1);<a name="line.273"></a>
<FONT color="green">274</FONT>                                            if (row != pos1) {<a name="line.274"></a>
<FONT color="green">275</FONT>                                    kn.swapRows(row, pos1);<a name="line.275"></a>
<FONT color="green">276</FONT>                                    int tmp = rowMapping[row];<a name="line.276"></a>
<FONT color="green">277</FONT>                                    rowMapping[row]         = rowMapping[pos1];<a name="line.277"></a>
<FONT color="green">278</FONT>                                    rowMapping[pos1]        = tmp;<a name="line.278"></a>
<FONT color="green">279</FONT>                                            }<a name="line.279"></a>
<FONT color="green">280</FONT>                                            else {<a name="line.280"></a>
<FONT color="green">281</FONT>                                                    row++;                                                  <a name="line.281"></a>
<FONT color="green">282</FONT>                                            }<a name="line.282"></a>
<FONT color="green">283</FONT>                                    }<a name="line.283"></a>
<FONT color="green">284</FONT>                            }<a name="line.284"></a>
<FONT color="green">285</FONT>                            else {<a name="line.285"></a>
<FONT color="green">286</FONT>                                    row++;<a name="line.286"></a>
<FONT color="green">287</FONT>                            }<a name="line.287"></a>
<FONT color="green">288</FONT>                    }<a name="line.288"></a>
<FONT color="green">289</FONT>                    }<a name="line.289"></a>
<FONT color="green">290</FONT>            if (pivots.length() == cols &amp;&amp; pivots.cardinality() == cols) {<a name="line.290"></a>
<FONT color="green">291</FONT>                    //we have found all metas of the identity matrix, so we're done<a name="line.291"></a>
<FONT color="green">292</FONT>                    return reestablishReactionCategoryOrder(metaNet, kn, rowMapping, config);<a name="line.292"></a>
<FONT color="green">293</FONT>            }<a name="line.293"></a>
<FONT color="green">294</FONT>            else {<a name="line.294"></a>
<FONT color="green">295</FONT>                    final String msg = <a name="line.295"></a>
<FONT color="green">296</FONT>                            "identity matrix not found in big integer rational matrix, found " + <a name="line.296"></a>
<FONT color="green">297</FONT>                                    pivots.cardinality() + " of " + cols + ": " + pivots;<a name="line.297"></a>
<FONT color="green">298</FONT>                    LOG.warning(msg);<a name="line.298"></a>
<FONT color="green">299</FONT>                    throw new RuntimeException(msg);<a name="line.299"></a>
<FONT color="green">300</FONT>                    //return formatKernel(kn.toDoubleMatrix(false), rowMapping, constraints);<a name="line.300"></a>
<FONT color="green">301</FONT>            }<a name="line.301"></a>
<FONT color="green">302</FONT>        }<a name="line.302"></a>
<FONT color="green">303</FONT>        /**<a name="line.303"></a>
<FONT color="green">304</FONT>         * Due to kernel formatting (formatting the row-echelon kernel matrix), the<a name="line.304"></a>
<FONT color="green">305</FONT>         * category ordering (put enforced and no-split reactions to end) is <a name="line.305"></a>
<FONT color="green">306</FONT>         * intermixed. Here, we reestablish this order, but still preserving the<a name="line.306"></a>
<FONT color="green">307</FONT>         * row-echelon form.<a name="line.307"></a>
<FONT color="green">308</FONT>         * <a name="line.308"></a>
<FONT color="green">309</FONT>         * E.g. we have<a name="line.309"></a>
<FONT color="green">310</FONT>         * [ I ]<a name="line.310"></a>
<FONT color="green">311</FONT>         * [ M ]<a name="line.311"></a>
<FONT color="green">312</FONT>         * and some reaction i in the identity part has to be moved to the end due<a name="line.312"></a>
<FONT color="green">313</FONT>         * to some category constraint. We exchange row i and the last one. Now, we<a name="line.313"></a>
<FONT color="green">314</FONT>         * have<a name="line.314"></a>
<FONT color="green">315</FONT>         * [1 0 ... 0 ]<a name="line.315"></a>
<FONT color="green">316</FONT>         * [0 1 ... 0 ]<a name="line.316"></a>
<FONT color="green">317</FONT>         * [x x     x ] &lt;-- row i<a name="line.317"></a>
<FONT color="green">318</FONT>         * [0 ...   1 ]<a name="line.318"></a>
<FONT color="green">319</FONT>         * [    M'    ]<a name="line.319"></a>
<FONT color="green">320</FONT>         * By adding/subtracting columns, we can reestablish the identity matrix at<a name="line.320"></a>
<FONT color="green">321</FONT>         * row i. <a name="line.321"></a>
<FONT color="green">322</FONT>         * Note: if the last row did not have a non-zero entry at column i, we <a name="line.322"></a>
<FONT color="green">323</FONT>         * search for another row in the M part which has an non-zero entry at<a name="line.323"></a>
<FONT color="green">324</FONT>         * column i and swap it with the last row.<a name="line.324"></a>
<FONT color="green">325</FONT>         */<a name="line.325"></a>
<FONT color="green">326</FONT>        private static &lt;N extends Number, M extends ReadableDoubleMatrix&lt;N&gt; &amp; WritableMatrix&lt;N&gt;&gt; M reestablishReactionCategoryOrder(MetabolicNetwork metaNet, M kn, int[] rowMapping, Config config) {<a name="line.326"></a>
<FONT color="green">327</FONT>            final LogWriter logFinest = new LogWriter(LOG, Level.FINEST);<a name="line.327"></a>
<FONT color="green">328</FONT>                    if (Loggers.isLoggable(LOG, Level.FINEST)) {<a name="line.328"></a>
<FONT color="green">329</FONT>                            LOG.finest("formatted kernel before reestablishing reaction category sorting:");<a name="line.329"></a>
<FONT color="green">330</FONT>                            kn.writeToMultiline(logFinest);<a name="line.330"></a>
<FONT color="green">331</FONT>                    }<a name="line.331"></a>
<FONT color="green">332</FONT>                    final NumberOperations&lt;N&gt; nops = kn.getNumberOperations();<a name="line.332"></a>
<FONT color="green">333</FONT>            final ReactionMapping rmap = new ReactionMapping(config, metaNet, rowMapping);<a name="line.333"></a>
<FONT color="green">334</FONT>            final int cols = kn.getColumnCount();<a name="line.334"></a>
<FONT color="green">335</FONT>            final int rows = kn.getRowCount();<a name="line.335"></a>
<FONT color="green">336</FONT>            int rowsActive = rows;<a name="line.336"></a>
<FONT color="green">337</FONT>            for (final ReactionMapping.Category cat : ReactionMapping.Category.values()) {<a name="line.337"></a>
<FONT color="green">338</FONT>                    if (cat.isSpecial()) {<a name="line.338"></a>
<FONT color="green">339</FONT>                    for (int row = 0; row &lt; cols; row++) {<a name="line.339"></a>
<FONT color="green">340</FONT>                                    if (cat == rmap.getReactionCategoryBySortedIndex(row)) {<a name="line.340"></a>
<FONT color="green">341</FONT>                                                    LOG.finest("row " + row + " is " + cat);<a name="line.341"></a>
<FONT color="green">342</FONT>                                            //swap this row with last active row<a name="line.342"></a>
<FONT color="green">343</FONT>                                            rowsActive--;<a name="line.343"></a>
<FONT color="green">344</FONT>                                                    LOG.finest("swapping rows " + row + " and " + rowsActive);<a name="line.344"></a>
<FONT color="green">345</FONT>                                            kn.swapRows(row, rowsActive);<a name="line.345"></a>
<FONT color="green">346</FONT>                                            ch.javasoft.util.Arrays.swap(rowMapping, row, rowsActive);<a name="line.346"></a>
<FONT color="green">347</FONT>                                            if (Loggers.isLoggable(LOG, Level.FINEST)) {<a name="line.347"></a>
<FONT color="green">348</FONT>                                                    LOG.finest("formatted after swapping last/" + row);<a name="line.348"></a>
<FONT color="green">349</FONT>                                                    kn.writeToMultiline(logFinest);<a name="line.349"></a>
<FONT color="green">350</FONT>                                            }<a name="line.350"></a>
<FONT color="green">351</FONT>                                            //check the replacement row, is it<a name="line.351"></a>
<FONT color="green">352</FONT>                                            //  a) a row with non-zero pivot<a name="line.352"></a>
<FONT color="green">353</FONT>                                            //  b) not a special category row  <a name="line.353"></a>
<FONT color="green">354</FONT>                                            if (kn.getSignumAt(row, row) == 0 || rmap.getReactionCategoryBySortedIndex(row).isSpecial()) {<a name="line.354"></a>
<FONT color="green">355</FONT>                                                    //look for another non-special category row with non-zero pivot<a name="line.355"></a>
<FONT color="green">356</FONT>                                                    int nonZeroRow = -1;<a name="line.356"></a>
<FONT color="green">357</FONT>                                                    for (int i = cols; i &lt; rowsActive; i++) {<a name="line.357"></a>
<FONT color="green">358</FONT>                                                            if (kn.getSignumAt(i, row) != 0) {<a name="line.358"></a>
<FONT color="green">359</FONT>                                                                    if (rmap.getReactionCategoryBySortedIndex(i).isSpecial()) {<a name="line.359"></a>
<FONT color="green">360</FONT>                                                                            LOG.finest("swap candidate " + i + " is " + rmap.getReactionCategoryBySortedIndex(i));<a name="line.360"></a>
<FONT color="green">361</FONT>                                                                    }<a name="line.361"></a>
<FONT color="green">362</FONT>                                                                    else {<a name="line.362"></a>
<FONT color="green">363</FONT>                                                                            nonZeroRow = i;<a name="line.363"></a>
<FONT color="green">364</FONT>                                                                            break;<a name="line.364"></a>
<FONT color="green">365</FONT>                                                                    }<a name="line.365"></a>
<FONT color="green">366</FONT>                                                            }<a name="line.366"></a>
<FONT color="green">367</FONT>                                                    }<a name="line.367"></a>
<FONT color="green">368</FONT>                                                    if (nonZeroRow &lt; 0) {<a name="line.368"></a>
<FONT color="green">369</FONT>    //                                                      LOG.info("cannot process special reaction " + row + " at end, no replacement row found in kernel matrix");<a name="line.369"></a>
<FONT color="green">370</FONT>    //                                                      //swap back<a name="line.370"></a>
<FONT color="green">371</FONT>    //                                                      LOG.finest("back-swapping rows " + row + " and " + rowsActive);<a name="line.371"></a>
<FONT color="green">372</FONT>    //                                              kn.swapRows(row, rowsActive);<a name="line.372"></a>
<FONT color="green">373</FONT>    //                                              ch.javasoft.util.Arrays.swap(rowMapping, row, rowsActive);<a name="line.373"></a>
<FONT color="green">374</FONT>    //                                              if (Loggers.isLoggable(LOG, Level.FINEST)) {<a name="line.374"></a>
<FONT color="green">375</FONT>    //                                                      LOG.finest("formatted after back-swapping last/" + row);<a name="line.375"></a>
<FONT color="green">376</FONT>    //                                                      kn.writeToMultiline(logFinest);<a name="line.376"></a>
<FONT color="green">377</FONT>    //                                              }<a name="line.377"></a>
<FONT color="green">378</FONT>    //                                              rowsActive++;<a name="line.378"></a>
<FONT color="green">379</FONT>                                                            kn.writeToMultiline(new LogWriter(LOG, Level.WARNING));         <a name="line.379"></a>
<FONT color="green">380</FONT>                                                            throw new RuntimeException("no replacement row found with non-zero pivot to reastablish row-echelon form of kernel matrix for row " + row);<a name="line.380"></a>
<FONT color="green">381</FONT>                                                    }<a name="line.381"></a>
<FONT color="green">382</FONT>                                                    else {<a name="line.382"></a>
<FONT color="green">383</FONT>                                                                    LOG.finest("swapping rows " + row + " and " + nonZeroRow);<a name="line.383"></a>
<FONT color="green">384</FONT>                                                            kn.swapRows(row, nonZeroRow);<a name="line.384"></a>
<FONT color="green">385</FONT>                                                            ch.javasoft.util.Arrays.swap(rowMapping, row, nonZeroRow);<a name="line.385"></a>
<FONT color="green">386</FONT>                                                    if (Loggers.isLoggable(LOG, Level.FINEST)) {<a name="line.386"></a>
<FONT color="green">387</FONT>                                                            LOG.finest("formatted after swapping rows " + row + " and " + nonZeroRow);<a name="line.387"></a>
<FONT color="green">388</FONT>                                                            kn.writeToMultiline(logFinest);<a name="line.388"></a>
<FONT color="green">389</FONT>                                                    }<a name="line.389"></a>
<FONT color="green">390</FONT>                                                    }<a name="line.390"></a>
<FONT color="green">391</FONT>                                            }<a name="line.391"></a>
<FONT color="green">392</FONT>                                            //reestablish identity part now<a name="line.392"></a>
<FONT color="green">393</FONT>                                            if (!nops.isOne(kn.getNumberValueAt(row, row))) {<a name="line.393"></a>
<FONT color="green">394</FONT>                                                    //make pivot a 1<a name="line.394"></a>
<FONT color="green">395</FONT>                                                    final N piv = kn.getNumberValueAt(row, row);<a name="line.395"></a>
<FONT color="green">396</FONT>                                                    for (int r = cols; r &lt; rows; r++) {<a name="line.396"></a>
<FONT color="green">397</FONT>                                                            final N div = nops.divide(kn.getNumberValueAt(r, row), piv);<a name="line.397"></a>
<FONT color="green">398</FONT>                                                            kn.setValueAt(r, row, nops.reduce(div));<a name="line.398"></a>
<FONT color="green">399</FONT>                                                    }<a name="line.399"></a>
<FONT color="green">400</FONT>                                                    kn.setValueAt(row, row, nops.one());<a name="line.400"></a>
<FONT color="green">401</FONT>                                            }<a name="line.401"></a>
<FONT color="green">402</FONT>                                            for (int col = 0; col &lt; cols; col++) {<a name="line.402"></a>
<FONT color="green">403</FONT>                                                    if (col != row) {<a name="line.403"></a>
<FONT color="green">404</FONT>                                                            //make entries 0<a name="line.404"></a>
<FONT color="green">405</FONT>                                                            if (kn.getSignumAt(row, col) != 0) {<a name="line.405"></a>
<FONT color="green">406</FONT>                                                                    // col = col - colpiv * pivval<a name="line.406"></a>
<FONT color="green">407</FONT>                                                                    final N colpiv = kn.getNumberValueAt(row, col);<a name="line.407"></a>
<FONT color="green">408</FONT>                                                                    for (int r = cols; r &lt; rows; r++) {<a name="line.408"></a>
<FONT color="green">409</FONT>                                                                            final N pivval  = kn.getNumberValueAt(r, row); <a name="line.409"></a>
<FONT color="green">410</FONT>                                                                            final N val     = kn.getNumberValueAt(r, col);<a name="line.410"></a>
<FONT color="green">411</FONT>                                                                            final N sub             = nops.multiply(pivval, colpiv);<a name="line.411"></a>
<FONT color="green">412</FONT>                                                                            final N newval  = nops.subtract(val, sub);<a name="line.412"></a>
<FONT color="green">413</FONT>                                                                            kn.setValueAt(r, col, nops.reduce(newval));<a name="line.413"></a>
<FONT color="green">414</FONT>                                                                    }<a name="line.414"></a>
<FONT color="green">415</FONT>                                                                    kn.setValueAt(row, col, nops.zero());<a name="line.415"></a>
<FONT color="green">416</FONT>                                                            }<a name="line.416"></a>
<FONT color="green">417</FONT>                                                    }<a name="line.417"></a>
<FONT color="green">418</FONT>                                            }<a name="line.418"></a>
<FONT color="green">419</FONT>                                    }<a name="line.419"></a>
<FONT color="green">420</FONT>                            }<a name="line.420"></a>
<FONT color="green">421</FONT>                    }<a name="line.421"></a>
<FONT color="green">422</FONT>            }<a name="line.422"></a>
<FONT color="green">423</FONT>                    if (Loggers.isLoggable(LOG, Level.FINEST)) {<a name="line.423"></a>
<FONT color="green">424</FONT>                            LOG.finest("formatted kernel after reestablishing reaction category sorting:");<a name="line.424"></a>
<FONT color="green">425</FONT>                            kn.writeToMultiline(logFinest);<a name="line.425"></a>
<FONT color="green">426</FONT>                    }<a name="line.426"></a>
<FONT color="green">427</FONT>            return kn;<a name="line.427"></a>
<FONT color="green">428</FONT>        }<a name="line.428"></a>
<FONT color="green">429</FONT>        <a name="line.429"></a>
<FONT color="green">430</FONT>            public static &lt;N extends Number&gt; ReadableMatrix&lt;N&gt; mulMapped(ReadableMatrix&lt;N&gt; stoich, ReadableMatrix&lt;N&gt; kn, int[] rowMapping) {<a name="line.430"></a>
<FONT color="green">431</FONT>                    final ReadableMatrix&lt;N&gt; knUnmapped = rowMapping == null ? kn : ReactionMapping.unsortKernelMatrixRows(kn, rowMapping);<a name="line.431"></a>
<FONT color="green">432</FONT>                    return Mul.multiplyGeneric(stoich, knUnmapped);<a name="line.432"></a>
<FONT color="green">433</FONT>            }<a name="line.433"></a>
<FONT color="green">434</FONT>            <a name="line.434"></a>
<FONT color="green">435</FONT>            private static double[] mapRows(double[] values, int[] rowMapping) {<a name="line.435"></a>
<FONT color="green">436</FONT>                    double[] res = new double[values.length];<a name="line.436"></a>
<FONT color="green">437</FONT>                    for (int ii = 0; ii &lt; res.length; ii++) {<a name="line.437"></a>
<FONT color="green">438</FONT>                            res[rowMapping[ii]] = values[ii];<a name="line.438"></a>
<FONT color="green">439</FONT>                    }<a name="line.439"></a>
<FONT color="green">440</FONT>                    return res;<a name="line.440"></a>
<FONT color="green">441</FONT>            }<a name="line.441"></a>
<FONT color="green">442</FONT>            <a name="line.442"></a>
<FONT color="green">443</FONT>            private static int[] rowUnmappings(int[] rowMapping) {<a name="line.443"></a>
<FONT color="green">444</FONT>                    int[] unmapping = new int[rowMapping.length];<a name="line.444"></a>
<FONT color="green">445</FONT>                    for (int ii = 0; ii &lt; unmapping.length; ii++) {<a name="line.445"></a>
<FONT color="green">446</FONT>                            unmapping[rowMapping[ii]] = ii;<a name="line.446"></a>
<FONT color="green">447</FONT>                    }<a name="line.447"></a>
<FONT color="green">448</FONT>                    return unmapping;<a name="line.448"></a>
<FONT color="green">449</FONT>            }<a name="line.449"></a>
<FONT color="green">450</FONT>            <a name="line.450"></a>
<FONT color="green">451</FONT>    }<a name="line.451"></a>




























































</PRE>
</BODY>
</HTML>
